import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

import javafx.scene.image.Image;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;

/**
 * }eA[_[
 * <pre>
 * </pre>
 */
public class MaterialReader {

	/**
	 * fobOx
	 * <pre>
	 * ʏ0ɂĂB
	 * PŊTvxAQŏڍ׃x܂ŏo͂܂B
	 * </pre>
	 */
	private static int			lvlDebug			= 0;

	/**
	 * }eA擾
	 * @param strFilePath t@CpX
	 * @return HashMap<String, PhongMaterial> }eÃ}eAԋp܂B
	 */
	public static HashMap<String, PhongMaterial> getMaterials(String strFilePath) throws Exception {

		// ftHgpX
		String				strDefaultPath	= null;

		// InputStream
		InputStream			is				= null;

		// InputStreamReader
		InputStreamReader	isr				= null;

		// LineNumberReade
		LineNumberReader	lnr				= null;

		// siG[\pj
		int row = 0;

		try{

			// fobOo
			outputDebugInfo(1, "START MaterialReader. strFilePath:" + strFilePath);

			// t@CpX̃ftHgpXێ
			int indexDefaultPath = strFilePath.lastIndexOf("/");
			if(indexDefaultPath == -1){
				strDefaultPath = "";
			}else{
				strDefaultPath = strFilePath.substring(0, indexDefaultPath + 1);
			}

			// InputStream𐶐
			is = ObjReader.application.getClass().getResourceAsStream(strFilePath);

			// t@CȂꍇA
			if(is == null){
				// G[X[
				throw new IllegalStateException("File Not Found. filePath = " + strFilePath);
			}

			// InputStreamReader𐶐
			isr = new InputStreamReader(is);

			// LineNumberReader𐶐
			lnr = new LineNumberReader(isr);

			// }eA}bv
			HashMap<String, PhongMaterial> mapMaterial = new HashMap<String, PhongMaterial>();

			// }eA
			String strMaterialName = null;

			// }eA
			PhongMaterial material = null;

			// sA[v
			while(true){

				// s{P
				row++;

				// Ps擾
				String strLine = lnr.readLine();

				// s񂪎擾łȂꍇA
				if(strLine == null){
					// [v𔲂
					break;
				}

				// g[N𐶐
				StringTokenizer stLine = new StringTokenizer(strLine, " ");

				// ꗗ
				ArrayList<String> strLst = new ArrayList<String>(5);

				// g[NA[v
				while(true){

					// g[NȂꍇA
					if(!stLine.hasMoreTokens()){
						// [v𔲂
						break;
					}

					// g[N𕶎ꗗɊi[
					strLst.add(stLine.nextToken());

				} // end while g[NA[v

				// 񂪎擾łȂꍇA
				if(strLst.size() == 0){
					// ReBj[
					continue;
				}

				//
				// e擾
				//

				// }eȀꍇA
				if(strLst.get(0).equals("newmtl")){

					// }eAɑ݂ꍇA
					if(strMaterialName != null){

						// }eAݒۑ
						mapMaterial.put(strMaterialName, material);

					}

					// }eAۑ
					strMaterialName = strLst.get(1);

					// }eA𐶐
					material = new PhongMaterial();

				// XyLw̏ꍇA
				}else if(strLst.get(0).equals("Ns")){

					// XyLwݒ
					material.setSpecularPower(Double.parseDouble(strLst.get(1)));

					// fobOo
					outputDebugInfo(1, "Ns=" + strLst.get(1));

				// XyLF̏ꍇA
				// ʔ
				}else if(strLst.get(0).equals("Ks")){

					// J[擾
					Color color = MaterialReader.getColor(strLst);

					// XyLFiʔˁjݒ
					material.setSpecularColor(color);

					// fobOo
					outputDebugInfo(1, "Ks=" + color);

				// ArGgF̏ꍇA
				// 
				}else if(strLst.get(0).equals("Ka")){

				// fBt[YF̏ꍇA
				// gU
				}else if(strLst.get(0).equals("Kd")){

					// J[擾
					Color color = MaterialReader.getColor(strLst);

					// fBt[YFigUˁjݒ
					material.setDiffuseColor(color);

					// fobOo
					outputDebugInfo(1, "Kd=" + color);

				// ov}bv̏ꍇA
				}else if(strLst.get(0).equals("map_Bump")){

					// C[W擾
					Image image = MaterialReader.getImage(strDefaultPath, strLst);

					// ov}bvݒ
					material.setBumpMap(image);

				// fBt[YeNX`}bv̏ꍇA
				// gU}bv
				}else if(strLst.get(0).equals("map_Kd")){

					// C[W擾
					Image image = MaterialReader.getImage(strDefaultPath, strLst);

					// fBt[YeNX`}bvigU}bvjݒ
					material.setDiffuseMap(image);

				// ȏƖ}bv̏ꍇA
				}else if(strLst.get(0).equals("???")){

					// C[W擾
					Image image = MaterialReader.getImage(strDefaultPath, strLst);

					// ȏƖ}bvݒ
					material.setSelfIlluminationMap(image);

				// XyLJ[eNX`}bv
				// ʃ}bv̏ꍇA
				}else if(strLst.get(0).equals("map_Ks")){

					// C[W擾
					Image image = MaterialReader.getImage(strDefaultPath, strLst);

					// XyLJ[eNX`}bviʃ}bvjݒ
					material.setSpecularMap(image);

				} // end if

			} // end while sA[v

			// }eAɑ݂ꍇA
			if(strMaterialName != null){

				// }eAݒۑ
				mapMaterial.put(strMaterialName, material);

			}

			// ЂƂȏA}eAݒ肪ꍇA
			if(mapMaterial.size() >= 1){

				// ^[
				return mapMaterial;

			}

			// fobOo
			outputDebugInfo(1, "END MaterialReader. strFilePath:" + strFilePath);

			// ^[
			return null;

		}catch(Exception ex){

			// sȑꍇA
			if(row > 0){
				// G[̂so
				System.out.println("Error! row = : " + row);
			}

			// ̂܂܃G[X[
			throw ex;

		}finally{

			try{
				// N[Y
				if(isr != null){
					isr.close();
				}
			}catch(Exception ex){
				ex.printStackTrace();
			}

		}

	} // end getMaterials

	/**
	 * J[擾
	 * <pre>
	 * eLXgf[^J[IuWFNg擾܂B
	 * </pre>
	 * @param strLst ꗗ
	 * @return Color J[IuWFNg
	 */
	private static Color getColor(ArrayList<String> strLst){

		Color color = Color.color(Double.parseDouble(strLst.get(1)),
									Double.parseDouble(strLst.get(2)),
									Double.parseDouble(strLst.get(3))
		);

		return color;

	} // end getColor

	/**
	 * C[W擾
	 * <pre>
	 * t@CpXC[W擾܂B
	 * BMP/GIF/JPEG/PNGΏۂƂ܂B
	 * </pre>
	 * @param strDefaultPath ftHgpX
	 * @param strLst ꗗ
	 * @return Image C[WIuWFNg
	 */
	private static Image getImage(String strDefaultPath, ArrayList<String> strLst){

		// fobOo
		outputDebugInfo(1, "START getImage.");

		// ꗗ̌擾
		int countStrLst = strLst.size();

		// ꗗ̌A[v
		for(int i = 1; i < countStrLst; i++){

			// t@Cij擾
			String strPath = strLst.get(i);

			// gq̈ʒu擾
			int index = strPath.lastIndexOf(".");

			// gq̈ʒu擾łꍇA
			if(index != -1){

				// gq擾A啶ɕϊ
				String sttExt = strPath.substring(index + 1).toUpperCase();;

				// gqΏۂ̊gq̏ꍇA
				if(sttExt.equals("BMP") || sttExt.equals("GIF") || sttExt.equals("PNG") ||
					sttExt.equals("JPG") || sttExt.equals("JPEG") || sttExt.equals("JPE") || sttExt.equals("JFIF")){

					// URIpX擾
					String strURIPath = new File(strDefaultPath + strPath).toURI().toString();

					// C[W擾
					Image image = new Image(strURIPath);

					// fobOo
					outputDebugInfo(2, "strURIPath:" + strURIPath);
					outputDebugInfo(2, "image:" + image);
					outputDebugInfo(2, "isError:" + image.isError());

					return image;

				} // end if gqΏۂ̊gq̏ꍇ

			} // end if gq̈ʒu擾łꍇ

		} // end for ꗗ̌A[v

		// fobOo
		outputDebugInfo(1, "END getImage.");

		// nullŃ^[
		return null;

	} // end getImage

	/**
	 * fobOo
	 * <pre>
	 * fobOx`FbNAR\[ɏo͂܂B
	 * </pre>
	 * @param strDebugInfo fobO
	 */
	private static void outputDebugInfo(int lvlDebug, String strDebugInfo){

		if(lvlDebug <= MaterialReader.lvlDebug){

			System.out.println(strDebugInfo);

		}

	} // end outputDebugInfo

}
