import java.util.ArrayList;
import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.geometry.Bounds;
import javafx.geometry.BoundingBox;

/**
 * bN
 * <pre>
 * bNdg݂S܂B
 * bNꗗێAKvɉAGXvCg̕߂s܂B
 * ԂoꍇAGXvCgbNKvȏꍇi͈͂Om[h폜^jA
 * bN܂B
 *
 * ǂ̃NXɑgݍƎvĂ܂A
 * v₱āAVvȍڎw߁A
 * PƂ̃NXƍ邱ƂƂ܂B
 * </pre>
 */
public class PRLock {

	/** AvP[V */
	private		PRApplication				application			= null;

	/** bNIXvCgꗗ */
	private		ArrayList<PRSpriteT>		spriteLockLst		= null;

	/** Ԉꗗ */
	private		ArrayList<int[]>			timeLst				= null;

	/** bNIΏۊOXvCgꗗ */
	private		ArrayList<PRSpriteT>		spriteLockNoLst		= null;

	/** ԑΏۊOꗗ */
	private		ArrayList<int[]>			timeNoLst			= null;

	/**
	 * RXgN^
	 * @param application AvP[V
	 */
	public PRLock(PRApplication application){

		// AvP[Vێ
		this.application = application;

		// bNIXvCgꗗ𐶐
		spriteLockLst = new ArrayList<PRSpriteT>(100);

		// Ԉꗗ𐶐
		timeLst = new ArrayList<int[]>(100);

		// bNIΏۊOXvCgꗗ𐶐
		spriteLockNoLst = new ArrayList<PRSpriteT>(100);

		// ԑΏۊOꗗ𐶐
		timeNoLst = new ArrayList<int[]>(100);

	} // end PRLock

	/**
	 * bNI
	 * <pre>
	 * bNI܂B
	 * 1/6bɃ`FbNAXvCgꗗɓo^Ăŏ̕烍bN邩`FbN܂B
	 * </pre>
	 */
	public void lockon(){

		// vC[擾
		PRSpritePrusher spritePrusher = this.application.getPRSpritePrusher();

		// E擾
		Bounds boundsPrusher = spritePrusher.getBoundsInParent();

		// bNI͈͂ݒ
		Bounds boundsLock = new BoundingBox(
			boundsPrusher.getMinX() - 0.02,
			boundsPrusher.getMinY() - 0.02,
			boundsPrusher.getMinZ(),
			boundsPrusher.getWidth() + 0.04,
			boundsPrusher.getHeight() + 0.04,
			boundsPrusher.getDepth() + 100.0
		);

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = this.application.getNodeLst();

		// XvCgꗗ̌擾
		int countNodeLst = nodeLst.size();

		// XvCgꗗ̌A[v
		for(int i = 0; i < countNodeLst; i++){

			// XvCg擾
			Node node = nodeLst.get(i);

			// GXvCgł͂ȂꍇA
			if(!(node instanceof PRSpriteT)){
				// ReBj[
				continue;
			}

			// G؂̏ꍇA
			if(node instanceof PRSpriteShrub){
				// ReBj[
				continue;
			}

			// G؂̏ꍇA
			if(node instanceof PRSpriteTree){
				// ReBj[
				continue;
			}

			// ̏ꍇA
			if(node instanceof PRSpritePole){
				// ReBj[
				continue;
			}

			// ȑꍇA
			if(node instanceof PRSpriteBuilding){
				// ReBj[
				continue;
			}

			// _̏ꍇA
			if(node instanceof PRSpriteCloud){
				// ReBj[
				continue;
			}

			// ɃbNIĂꍇA
			if(spriteLockLst.indexOf(node) != -1){
				// ReBj[
				continue;
			}

			// bNIΏۊOXvCgꗗɑ݂ꍇA
			if(spriteLockNoLst.indexOf(node) != -1){
				// ReBj[
				continue;
			}

			// bNI͈͂̏ꍇA
			if(boundsLock.intersects(node.getBoundsInParent())){

				// GXvCgɃLXg
				PRSpriteT spriteT = (PRSpriteT)node;

				// bNIBbNIXvCgꗗɒǉ
				spriteLockLst.add(spriteT);

				// Ԉꗗɒǉ
				timeLst.add(new int[]{6});

				// bNX^[g
				this.application.startWaveLockon();

				// [v𔲂
				break;

			} // end if bNI͈͂̏ꍇ

		} // end for XvCgꗗ̌A[v

		// bNIXvCgꗗ100𒴂ꍇA
		if(spriteLockLst.size() > 100){

			// bNIXvCgꗗi[Nj𐶐
			ArrayList<PRSpriteT> spriteLockWkLst = new ArrayList<PRSpriteT>(100);

			// Ԉꗗi[Nj𐶐
			ArrayList<int[]> timeWkLst = new ArrayList<int[]>(100);

			// bNIXvCgꗗ̌擾
			int countSpriteLockLst = spriteLockLst.size();

			// bNIXvCgꗗ̌A[v
			for(int i = 0; i < countSpriteLockLst; i++){

				// bNIXvCg擾
				PRSpriteT spriteLock = this.spriteLockLst.get(i);

				// nullȊȌꍇA
				if(spriteLock != null){

					// bNIXvCgꗗi[Njɒǉ
					spriteLockWkLst.add(spriteLock);

					// Ԃ擾
					int[] times = this.timeLst.get(i);

					// Ԉꗗi[Njɒǉ
					timeWkLst.add(times);

				} // end if nullȊȌꍇ

			} // end for bNIXvCgꗗ̌A[v

			// bNIXvCgꗗւ
			this.spriteLockLst = spriteLockWkLst;

			// Ԉꗗւ
			this.timeLst = timeWkLst;

		} // end if bNIXvCgꗗ100𒴂ꍇ

	} // end lockon

	/**
	 * bNO
	 * <pre>
	 * ԂoꍇAbN܂B
	 * 1/6ɏs܂B
	 * </pre>
	 */
	public void unlock() {

		// bNIXvCgꗗ̌擾
		int countSpriteLockLst = spriteLockLst.size();

		// bNIXvCgꗗ̌A[v
		for(int i = 0; i < countSpriteLockLst;i++){

			// Ԃ擾
			int[] times = timeLst.get(i);

			// null̏ꍇA
			if(times == null){
				// ReBj[
				continue;
			}

			// ԁ|P
			times[0]--;

			// Ԃ0ɂȂꍇA
			if(times[0] <= 0){

				// bNIXvCg擾
				PRSpriteT spriteLock = this.spriteLockLst.get(i);

				// bNIXvCgꗗ폜
				spriteLockLst.set(i, null);
				// Ԉꗗ폜
				timeLst.set(i, null);

				// bNIΏۊOXvCgꗗɒǉ
				spriteLockNoLst.add(spriteLock);
				// ԑΏۊOꗗɒǉ
				timeNoLst.add(new int[]{6});

			}

		} // end for bNꗗ̌A[v

		// bNIΏۊOXvCgꗗ̌擾
		int countSpriteLockNoLst = spriteLockNoLst.size();

		// bNIΏۊOXvCgꗗ̌A[v
		for(int i = 0; i < countSpriteLockNoLst;i++){

			// Ԃ擾
			int[] timeNos = timeNoLst.get(i);

			// null̏ꍇA
			if(timeNos == null){
				// ReBj[
				continue;
			}

			// ԁ|P
			timeNos[0]--;

			// Ԃ0ɂȂꍇA
			if(timeNos[0] <= 0){

				// bNIΏۊOXvCgꗗ폜
				spriteLockNoLst.set(i, null);
				// ԑΏۊOꗗ폜
				timeNoLst.set(i, null);

			}

		} // end for bNꗗ̌A[v

		// bNIΏۊOXvCgꗗ100𒴂ꍇA
		if(countSpriteLockNoLst > 100){

			// bNIΏۊOXvCgꗗi[Nj𐶐
			ArrayList<PRSpriteT> spriteLockNoWkLst = new ArrayList<PRSpriteT>(100);

			// ԑΏۊOꗗi[Nj𐶐
			ArrayList<int[]> timeNoWkLst = new ArrayList<int[]>(100);

			// bNIΏۊOXvCgꗗ̌A[v
			for(int i = 0; i < countSpriteLockNoLst; i++){

				// bNIXvCg擾
				PRSpriteT spriteLockNo = this.spriteLockNoLst.get(i);

				// nullȊȌꍇA
				if(spriteLockNo != null){

					// bNIΏۊOXvCgꗗi[Njɒǉ
					spriteLockNoWkLst.add(spriteLockNo);

					// Ԃ擾
					int[] timeNos = this.timeNoLst.get(i);

					// ԑΏۊOꗗi[Njɒǉ
					timeNoWkLst.add(timeNos);

				} // end if nullȊȌꍇ

			} // end for bNIΏۊOXvCgꗗ̌A[v

			// bNIΏۊOXvCgꗗւ
			this.spriteLockNoLst = spriteLockNoWkLst;

			// ԑΏۊOꗗւ
			this.timeNoLst = timeNoWkLst;

		} // end if bNIΏۊOXvCgꗗ100𒴂ꍇ

	} // end unlock

	/**
	 * m[h폜
	 * <pre>
	 * bNΏۂɂȂĂꍇ͊O܂B
	 * </pre>
	 */
	public void removeNode(Node node){

		// GXvCgł͂ȂꍇA
		if(!(node instanceof PRSpriteT)){
			// ^[
			return;
		}

		// CfbNX擾
		int index = spriteLockLst.indexOf(node);

		// bNIĂꍇA
		if(index != -1){

			// bNIXvCgꗗ폜
			spriteLockLst.set(index, null);
			// Ԉꗗ폜
			timeLst.set(index, null);

		}

		// CfbNX擾
		int indexNo = spriteLockNoLst.indexOf(node);

		// bNIΏۊOƂȂĂꍇA
		if(indexNo != -1){

			// bNIΏۊOXvCgꗗ폜
			spriteLockNoLst.set(indexNo, null);
			// ԑΏۊOꗗ폜
			timeNoLst.set(indexNo, null);

		}

	} // end removeNode

	/**
	 * bNIĂGXvCg擾
	 * <pre>
	 * bNIXvCgꗗɓo^Ăŏ̕烍bNIĂGXvCgԂ܂B
	 * </pre>
	 * @return PRSpriteT bNIĂGXvCgBbNIĂȂꍇ́Anull^[B
	 */
	public PRSpriteT getLockOnSpriteT(){

		// bNIXvCgꗗ̌擾
		int countSpriteLockLst = spriteLockLst.size();

		// bNIXvCgꗗ̌A[v
		for(int i = 0; i < countSpriteLockLst; i++){

			// bNIXvCg擾
			PRSpriteT spriteLock = this.spriteLockLst.get(i);

			// nullȊȌꍇA
			if(spriteLock != null){

				// bNIXvCgꗗ폜
				spriteLockLst.set(i, null);
				// Ԉꗗ폜
				timeLst.set(i, null);

				// bNIΏۊOXvCgꗗɒǉ
				spriteLockNoLst.add(spriteLock);
				// ԑΏۊOꗗɒǉ
				timeNoLst.add(new int[]{12});

				// bNIXvCg^[
				return spriteLock;

			} // end if nullȊȌꍇ

		} // end for bNIXvCgꗗ̌A[v

		// nullŃ^[
		return null;

	} // end getLockOnSpriteT

}
