import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;

/**
 * n
 */
public class PRSpriteGround extends PRSprite {

	private static float[]		POINTS		= {
		-100.0f, 0,  200.0f,
		-100.0f, 0, -200.0f,
		 100.0f, 0, -200.0f,
		 100.0f, 0,  200.0f
	};

	private static float[]		TEXCOORDS   = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static int[]		FACES		= {
		0, 0, 1, 0, 2, 0,
		2, 0, 3, 0, 0, 0
	};

	/** }eA */
	private		PhongMaterial	material	= null;

	/**
	 * 
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteGround(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// bVr[𐶐
			MeshView meshView = new MeshView();

			// bV𐶐
			TriangleMesh mesh = new TriangleMesh();

			mesh.getPoints().addAll(POINTS);
			mesh.getTexCoords().addAll(TEXCOORDS);
			mesh.getFaces().addAll(FACES);

			// }eA𐶐
			material = new PhongMaterial();
			material.setDiffuseColor(Color.DARKGREEN);

			// bVo^
			meshView.setMesh(mesh);
			meshView.setMaterial(material);

			// bVr[ǉ
			this.getChildren().add(meshView);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteGround

	/**
	 * Xe[Wݒ
	 * @param stage Xe[W
	 */
	public void setStage(int stage){

		// Xe[WPF_[NEO[
		if(stage == 1){
			this.setVisible(true);
			material.setDiffuseColor(Color.DARKGREEN);

		// Xe[WQF_[NEI[uEO[
		}else if(stage == 2){
			material.setDiffuseColor(Color.DARKOLIVEGREEN);

		// Xe[WRFB
		}else if(stage == 3){
			this.setVisible(false);

		}

	} // end setStage

	/**
	 * s
	 */
	@Override
	public void run(){

	} // end run

}
