import javafx.collections.ObservableList;
import javafx.geometry.Bounds;
import javafx.scene.Node;
import javafx.scene.transform.Rotate;

/**
 * AXeC_[
 * <pre>
 * ǁA₪DȃAXeC_[HIǂĂHIHI
 * </pre>
 */
public class PRSpriteShip extends PRSpriteT {

	/** Up^[ E */
	public static final int		POS_RIGHT		= PRSpriteGroupShip.POS_RIGHT;

	/** Up^[  */
	public static final int		POS_LEFT		= PRSpriteGroupShip.POS_LEFT;

	/** zup^[ */
	private		String			strPattern		= null;

	/** G̒eˏ */
	private		boolean			flgTamaTeki		= false;

	/** Uʒu */
	private 	int				pos				= 0;

	/**  */
	private 	int				time			= 0;

	/** XY */
	private		Rotate			rotateY			= null;
	private		double			angleY			= 180;

	/** XZ */
	private		Rotate			rotateZ			= null;
	private		double			angleZ			= 0;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteShip.class, "3d/Ship.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param stage Xe[W
	 * @param strPattern zup^[
	 */
	public PRSpriteShip(PRApplication application, String strPattern){

		// X[p[NXĂяo
		super(application);

		try{

			// p^[ێ
			this.strPattern = strPattern;

			// Zݒ
			super.setTranslateZ(200);

			// p^[ʂɐݒ
			if("͂Ȃ".equals(strPattern)){

				// Xݒ
				super.setTranslateX(-10.0);
				// Yݒ
				super.setTranslateY(-10.0);

				// ړݒ
				mz = -0.6;

			}else if("E͂Ȃ".equals(strPattern)){

				// Xݒ
				super.setTranslateX(10.0);
				// Yݒ
				super.setTranslateY(-10.0);

				// ړݒ
				mz = -0.6;

			}else if("͂".equals(strPattern)){

				// Xݒ
				super.setTranslateX(-2.0);
				// Yݒ
				super.setTranslateY(-3.0);

				// ړݒ
				mz = -0.6;

			}else if("E͂".equals(strPattern)){

				// Xݒ
				super.setTranslateX(2.0);
				// Yݒ
				super.setTranslateY(-3.0);

				// ړݒ
				mz = -0.6;

			}else if("U".equals(strPattern)){

				// Xݒ
				super.setTranslateX(Math.random() * 8.0 + 10.0);

				// Yݒ
				super.setTranslateY(Math.random() * 2.0 - 12.0);

				// ړݒ
				mx = -0.12;
				my =  0.06;
				mz = -0.88;

			} // end if p^[ʂɐݒ

			// IuWFNg
			ObjReader.create(this);

			// g^k
			super.setScaleX(0.5);
			super.setScaleY(0.5);
			super.setScaleZ(0.5);

			// eݒ
			application.addShadow(this, 0.8);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteShip

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param stage Xe[W
	 * @param strPattern zup^[
	 * @param pos Uʒu
	 */
	public PRSpriteShip(PRApplication application, String strPattern, int pos){

		// X[p[NXĂяo
		super(application);

		try{

			// p^[ێ
			this.strPattern = strPattern;

			// Uʒuێ
			this.pos = pos;

			if("납U".equals(strPattern)){

				// Rotate𐶐
				rotateY = new Rotate(angleY, Rotate.Y_AXIS);

				// ]pɓo^
				this.getTransforms().add(rotateY);

				// Rotate𐶐
				rotateZ = new Rotate(angleZ, Rotate.Z_AXIS);

				// ]pɓo^
				this.getTransforms().add(rotateZ);

				// Yݒ
				super.setTranslateY(-2.0);

				// Zݒ
				super.setTranslateZ(0);

				// Uʒu EA
				if(pos == POS_RIGHT){

					// XݒBEo
					super.setTranslateX(4.0);

				// Uʒu A
				}else{

					// XݒBo
					super.setTranslateX(-4.0);

				}

				// ړݒ
				mz =  1.00;

			} // end if p^[ʂɐݒ

			// IuWFNg
			ObjReader.create(this);

			// g^k
			super.setScaleX(0.5);
			super.setScaleY(0.5);
			super.setScaleZ(0.5);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteShip

	/**
	 * s
	 */
	@Override
	public void run(){

		// W擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// WZ
		x = x + mx;
		y = y + my;
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0 || z > 200){
			// 폜
			super.remove();
		}

		// p^[ʂɐݒ
		if("U".equals(strPattern)){

			// Z100؂ꍇA
			if(z < 100){

				// ܂̔sɐ؂ւ
				mx = 0;
				my = 0;

				// G̒e𔭎˂ĂȂꍇA
				if(!flgTamaTeki){

					// G̒e
					flgTamaTeki = true;

					// G̒e𐶐
					PRSpriteTamaTeki spriteTamaTeki = new PRSpriteTamaTeki(application, this, 1.0);
					// G̒eǉ
					application.addNode(spriteTamaTeki);

					// G̒eX^[g
					application.startWaveTamaTeki();

				} // end if G̒e𔭎˂ĂȂꍇ

			} // end if Z100؂ꍇA

		}else if("납U".equals(strPattern)){

			// ԁ{P
			time++;

			// 1.5b
			if(time < 90){

				// ȂɂȂ

			// 2.0b
			}else if(time < 120){

				// ]
				angleZ = angleZ + ((pos == POS_RIGHT)?3: -3);

				// pxݒ
				rotateZ.setAngle(angleZ);

			// 2.0b
			}else if(time == 120){

				// ړݒ
				mx = (pos == POS_RIGHT)?-0.3: 0.3;

				// G̒e𐶐
				PRSpriteTamaTeki spriteTamaTeki = new PRSpriteTamaTeki(application, this, 1.2);
				// G̒eǉ
				application.addNode(spriteTamaTeki);

				// G̒eX^[g
				application.startWaveTamaTeki();

			// 2.5b
			}else if(time < 150){

				// ]
				angleY = angleY + ((pos == POS_RIGHT)?-3: 3);

				// pxݒ
				rotateY.setAngle(angleY);

			// 2.5b
			}else if(time == 150){

				// ړݒ
				mz = 0;

			// 3.0b
			}else if(time < 180){

				// ȂɂȂ

			// 3.5b
			}else if(time < 210){

				// ]
				angleY = angleY + ((pos == POS_RIGHT)?-3: 3);

				// pxݒ
				rotateY.setAngle(angleY);

			// 3.5b
			}else if(time == 210){

				// ړݒ
				mz = -1.0;

			// 4.0b
			}else if(time == 240){

				// ړݒ
				mx = (pos == POS_RIGHT)?0.3: -0.3;

				// G̒e𐶐
				PRSpriteTamaTeki spriteTamaTeki = new PRSpriteTamaTeki(application, this, 1.2);
				// G̒eǉ
				application.addNode(spriteTamaTeki);

				// G̒eX^[g
				application.startWaveTamaTeki();

			} // end if 

		} // end if p^[ʂɐݒ

		// ړ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// 
						flgBomb = true;

						// e폜
						application.removeNode(node);

						// 𐶐
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this, 0.05);

						// AvP[Vɔǉ
						application.addNode(spriteBomb);

						// _ǉ
						application.addScore(500);

						// X^[g
						application.startWaveBomb();

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.5;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.5;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.6;
	}

}
