import javafx.scene.Group;
import javafx.scene.shape.MeshView;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;

/**
 * G̒e
 */
public class PRSpriteTamaTeki extends PRSpriteT {

	/** e̐F */
	private static final Color[]	COLOR_MISSILE		= new Color[]{
		Color.color(0.8, 0.3, 0.3),
		Color.color(0.8, 0.5, 0.3),
		Color.color(0.8, 0.6, 0.3),
		Color.color(0.8, 0.8, 0.3),
		Color.color(0.8, 0.6, 0.3),
		Color.color(0.8, 0.5, 0.3),
		Color.color(0.8, 0.3, 0.3)
	};

	/** }eA */
	private		PhongMaterial		materail		= null;

	/**  */
	private		int					time			= 0;

	/** x */
	private		double				mx				= 0;
	private		double				my				= 0;
	private		double				mz				= 0;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteTamaTeki.class, "3d/TamaTeki.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spritePrusher vC[
	 * @param speed G̒ẽXs[h
	 */
	public PRSpriteTamaTeki(PRApplication application, PRSprite sprite, double speed) {

		super(application);

		// IuWFNg
		ObjReader.create(this);

		// W
		double x = sprite.getTranslateX();
		double y = sprite.getTranslateY();
		double z = sprite.getTranslateZ();

		// ʒuݒ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// O[vEbVr[擾
		Group group = (Group)this.getChildren().get(0);
		MeshView meshView = (MeshView)(group.getChildren().get(0));

		// }eA擾
		materail = (PhongMaterial)meshView.getMaterial();

		// vC\擾
		PRSpritePrusher spritePrusher = application.getPRSpritePrusher();

		// W̍擾
		double saX = x - spritePrusher.getTranslateX();
		double saY = y - spritePrusher.getTranslateY();
		double saZ = z - spritePrusher.getTranslateZ();

		// y̕߂
		double bunkatu = saZ / speed;

		// xݒ
		mz = -speed;
		mx = -saX / bunkatu;
		my = -saY / bunkatu;

		// k
		super.setScaleX(0.5);
		super.setScaleY(0.5);
		super.setScaleZ(0.5);

		// eݒ
		application.addShadow(this);

	} // end PRSpriteTamaTeki

	/**
	 * s
	 */
	@Override
	public void run(){

		// ʒu擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// ړ
		x = x + mx;
		y = y + my;
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0){

			// 폜
			application.removeNode(this);

		}

		// ʒuݒ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// Ԑݒ
		time++;
		time = (time >= 7)?0: time;

		// e̐F̐ݒ
		materail.setDiffuseColor(COLOR_MISSILE[time]);
		materail.setSpecularColor(COLOR_MISSILE[time]);

		// ]
		super.setRotate(super.getRotate() + 10);

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 2.0;
	}
}
