import javafx.geometry.Point3D;
import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.geometry.Bounds;

/**
 * V
 */
public class PRSpriteTengu extends PRSpriteT {

	/** zup^[ */
	private		String					strPattern		= null;

	/** ]x */
	private		double					s				= Math.random() * 4 + 2;

	/** G̒eˏ */
	private		boolean					flgTamaTeki		= false;

	/** px */
	private		int						angle			= 0;

	/** G̒eˎ */
	private		int						timeTamaTeki	= 240;

	/** XvCgO[v */
	private		PRSpriteGroupTengu		spriteGroup		= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteTengu.class, "3d/Tengu.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param strParam zup^[
	 */
	public PRSpriteTengu(PRApplication application, String strParam){

		// X[p[NXĂяo
		super(application);

		try{

			// p^[ێ
			this.strPattern = strParam;

			// ȉꍇA
			if("i".equals(strPattern)){

				// Wݒ
				super.setTranslateX(Math.random() * 10.0 - 5.0);
				super.setTranslateY(Math.random() - 3.0);
				super.setTranslateZ(100);

				// xݒ
				mz = -1.0;

				// IuWFNg
				ObjReader.create(this);

				// ]
				Point3D p = new Point3D(0.0, 1.0, 0.0);

				// ]ݒ
				super.setRotationAxis(p);

			// E̍ȔꍇA
			}else if("E̍U".equals(strPattern)){

				// Wݒ
				super.setTranslateX(4.5);
				super.setTranslateY(Math.random() - 4.5 + application.getPRSpritePrusher().getTranslateY());
				super.setTranslateZ(30);

				// xݒ
				mx = -0.05;
				my =  0.06;
				mz = -0.40;

				// IuWFNg
				ObjReader.create(this);

				// ]
				Point3D p = new Point3D(0.0, 1.0, 0.0);

				// ]ݒ
				super.setRotationAxis(p);

			// ̍ȔꍇA
			}else if("̍U".equals(strPattern)){

				// Wݒ
				super.setTranslateX(-4.5);
				super.setTranslateY(Math.random() - 4.5 + application.getPRSpritePrusher().getTranslateY());
				super.setTranslateZ(30);

				// xݒ
				mx =  0.05;
				my =  0.06;
				mz = -0.40;

				// IuWFNg
				ObjReader.create(this);

				// ]
				Point3D p = new Point3D(0.0, -1.0, 0.0);

				// ]ݒ
				super.setRotationAxis(p);

			} // end if p^[

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteTengu

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spriteGroup XvCgO[v
	 * @param strParam zup^[
	 * @param angle px
	 */
	public PRSpriteTengu(PRApplication application, PRSpriteGroupTengu spriteGroup, String strParam, int angle){

		// X[p[NXĂяo
		super(application);

		try{

			// XvCgO[vێ
			this.spriteGroup = spriteGroup;

			// pxێ
			this.angle = angle;

			// p^[ێ
			this.strPattern = strParam;

			// {XP̏ꍇA
			if("{XP".equals(strPattern)){

				// g傷
				super.setScaleX(2.0);
				super.setScaleY(2.0);
				super.setScaleZ(2.0);

				// WAvZ
				double rad = angle * Math.PI / 180;

				// Wݒ
				super.setTranslateX(Math.sin(rad) * 3.6);
				super.setTranslateY(Math.cos(rad) * 3.6 - 6.0);
				super.setTranslateZ(150);

				// xݒ
				mz = -1.0;

				// IuWFNg
				ObjReader.create(this);

			} // end if p^[

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteTengu

	/**
	 * s
	 */
	@Override
	public void run(){

		// W擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// ȉꍇA
		if("i".equals(strPattern)){

			// WZ
			z = z + mz;

			// ʂ̊OɂłꍇA
			if(z < 0){
				// 폜
				super.remove();
			}

			// ړ
			super.setTranslateZ(z);

			// ]
			super.setRotate(getRotate() + this.s);

		// E̍ȔꍇA
		}else if("E̍U".equals(strPattern)){

			// WZ
			x = x + mx;
			y = y + my;
			z = z + mz;

			// ]P
			if(z < 8.0){
				z = 8.0;
				my = 0.0;
				mz = 0.0;
			}

			// ]Q
			if(x < -2.0){
				my = -0.06;
				mz =  0.40;
			} // end if ]P

			// G̒e𔭎˂ĂȂꍇA
			if(x < -4.0 && !flgTamaTeki){

				// G̒e
				flgTamaTeki = true;

				// G̒e𐶐
				PRSpriteTamaTeki spriteTamaTeki = new PRSpriteTamaTeki(application, this, 0.2);
				// G̒eǉ
				application.addNode(spriteTamaTeki);

				// G̒eX^[g
				application.startWaveTamaTeki();

			} // end if G̒e𔭎˂ĂȂꍇ

			// ʂ̊OɂłꍇA
			if(x < -5.0){
				// 폜
				super.remove();
			}

			// ړ
			super.setTranslateX(x);
			super.setTranslateY(y);
			super.setTranslateZ(z);

			// ]
			super.setRotate(getRotate() + this.s);

		// ̍ȔꍇA
		}else if("̍U".equals(strPattern)){

			// WZ
			x = x + mx;
			y = y + my;
			z = z + mz;

			// ]P
			if(z < 8.0){
				z = 8.0;
				my = 0.0;
				mz = 0.0;
			}

			// ]Q
			if(x > 2.0){
				my = -0.06;
				mz =  0.40;
			} // end if ]P

			// G̒e𔭎˂ĂȂꍇA
			if(x > 4.0 && !flgTamaTeki){

				// G̒e
				flgTamaTeki = true;

				// G̒e𐶐
				PRSpriteTamaTeki spriteTamaTeki = new PRSpriteTamaTeki(application, this, 0.2);
				// G̒eǉ
				application.addNode(spriteTamaTeki);

				// G̒eX^[g
				application.startWaveTamaTeki();

			} // end if G̒e𔭎˂ĂȂꍇ

			// ʂ̊OɂłꍇA
			if(x > 5.0){
				// 폜
				super.remove();
			}

			// ړ
			super.setTranslateX(x);
			super.setTranslateY(y);
			super.setTranslateZ(z);

			// ]
			super.setRotate(getRotate() + this.s);

		// {XP̏ꍇA
		}else if("{XP".equals(strPattern)){

			// WZ
			z = z + mz;

			// ~ʒuɂꍇA
			if(z < 20){
				// xOɐݒ
				mz = 0;
			}

			// pxZ
			angle = angle + 2;

			// WAvZ
			double rad = angle * Math.PI / 180;

			// ړ
			super.setTranslateX(Math.sin(rad) * 3.6);
			super.setTranslateY(Math.cos(rad) * 3.6 - 6.0);
			super.setTranslateZ(z);

			// G̒eԁ|P
			timeTamaTeki--;

			// G̒eˎԂ
			if(timeTamaTeki <= 0){

				// G̒e𐶐
				PRSpriteTamaTeki spriteTamaTeki = new PRSpriteTamaTeki(application, this, 0.30);
				// G̒eǉ
				application.addNode(spriteTamaTeki);

				// G̒eX^[g
				application.startWaveTamaTeki();

				// G̒eˎ */
				timeTamaTeki	= (int)(Math.random() * 60) + 180;

			} // end if G̒e𔭎˂ĂȂꍇ

		} // end if p^[

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// 
						flgBomb = true;

						// e폜
						application.removeNode(node);

						// 𐶐
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this);

						// AvP[Vɔǉ
						application.addNode(spriteBomb);

						// _ǉ
						application.addScore(500);

						// X^[g
						application.startWaveBomb();

						// {XP̏ꍇA
						if("{XP".equals(strPattern)){
							// XvCgO[vɍ폜ʒm
							spriteGroup.removeSprite();
						}

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.4;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.4;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
