import java.io.*;
import java.util.*;

/**
 * Xg[[NX
 * <pre>
 * ԂǗA^C~OAXvCgIuWFNg𐶐܂B
 * </pre>
 */
abstract public class PRStory implements PRConstant {

	/** AvP[V */
	private		PRApplication		application			= null;

	/** Xg[[Ԉꗗ */
	public		ArrayList<String>	timeLst				= null;
	/** Xg[[Cxgꗗ */
	public		ArrayList<String>	eventLst			= null;
	/** Xg[[p[^ꗗ */
	public		ArrayList<String>	paramLst			= null;

	/** Xg[[ */
	private		int					timeStory			= 0;
	/** Xg[[ */
	private		int					timeStoryNext		= 0;
	/** Cxg */
	private		String				storyEvent			= null;
	/** p[^ */
	private		String				strParam			= null;

	/** Xg[[CfbNX */
	private		int					indexStory			= -1;

	/** tO */
	private		boolean				flgProc				= true;

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param fileName t@C
	 */
	public PRStory(PRApplication application, String fileName) throws Exception {

		// AvP[Vێ
		this.application = application;

		timeLst = new ArrayList<String>(100);
		eventLst = new ArrayList<String>(100);
		paramLst = new ArrayList<String>(100);

		// [_[
		BufferedReader br = null;

		// [_[擾
		br = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(fileName)));

		// [v
		while(true){

			// Psǂݍ
			String strLine = br.readLine();

			// EOF̏ꍇA
			if(strLine == null){
				// uCN
				break;
			}

			// J}ʒu擾
			int index = strLine.indexOf(",");

			// J}ȂꍇA
			if(index == -1){
				// G[ŏI
				throw new IllegalStateException("J}܂B");
			}

			// ӂ߂̃J}ʒu擾
			int index2 = strLine.indexOf("," , index + 1);

			String strTime = strLine.substring(0, index);
			String strEvent = null;
			String strParam = null;

			// ӂ߂̃J}ʒu擾łȂꍇA
			if(index2 == -1){
				// Cxĝݎ擾
				strEvent = strLine.substring(index + 1);

			// ӂ߂̃J}ʒu擾ꍇA
			}else{
				// Cxgƃp[^擾
				strEvent = strLine.substring(index + 1, index2);
				strParam = strLine.substring(index2 + 1);

			} // end if

			// eꗗɒǉ
			timeLst.add(strTime);
			eventLst.add(strEvent);
			paramLst.add(strParam);

		} // end while

		// N[Y
		br.close();

	} // end PRStory

	/**
	 * ݎԎ擾
	 * return int ݎԁiQ[AXg[[̎ԁj
	 */
	public int getStoryTime(){

		return timeStory;

	} // end getTimeStory

	/**
	 * ̃CxgԎ擾
	 * return int ̃CxgԎ擾
	 */
	private String getTime(){

		return timeLst.get(indexStory);

	} // end getTime

	/**
	 * Cxg擾
	 * return String Cxg
	 */
	private String getEvent(){

		return eventLst.get(indexStory);

	} // end getEvent

	/**
	 * p[^擾
	 * return String p[^
	 */
	private String getParam(){

		return paramLst.get(indexStory);

	} // end getParam

	/**
	 * Ԃi߂
	 */
	public void next(){

		// Ԃi߂ꍇA
		if(flgProc){

			// Ԃi߂
			this.timeStory++;

			// ԂɂȂꍇA
			if(this.timeStory >= this.timeStoryNext){

				// Xg[[Cxg݂ꍇA
				if(storyEvent != null){

					// XvCgIuWFNg
					Object spriteObject = storyEvent(storyEvent, strParam);

					// XvCgO[v̏ꍇA
					if(spriteObject instanceof PRSpriteGroup){

						// AvP[VɃXvCgO[vǉ
						application.addSpriteGroup((PRSpriteGroup)spriteObject);

					// XvCg̏ꍇA
					}else if(spriteObject instanceof PRSprite){

						// AvP[VɃXvCgǉ
						application.addNode((PRSprite)spriteObject);

					}

				} // end if Xg[[Cxg݂ꍇ

				// Xg[[CfbNXi߂
				indexStory++;

				// Xg[[i߂
				timeStoryNext = Integer.parseInt(this.getTime());
				storyEvent = this.getEvent();
				strParam = this.getParam();

			} // end if ԂɂȂꍇ

		} // end if Ԃi߂ꍇ

	} // end next

	/**
	 * AvP[V擾
	 */
	public PRApplication getPRApplication(){
		return application;
	}

	/**
	 * Jn
	 */
	public void start(){
		flgProc = true;
	}

	/**
	 * ~
	 */
	public void stop(){
		flgProc = false;
	}

	/**
	 * Zbg
	 */
	public void reset(){

		timeStory = 0;
		timeStoryNext = 0;
		indexStory =  -1;

		// Xg[[Cxg
		storyEvent = null;
	}

	/**
	 * Xg[[Ăяo
	 * @param storyEvent Cxg
	 * @param strParam p[^
	 * @return XvCgIuWFNg
	 */
	abstract public Object storyEvent(String storyEvent, String strParam);

}
