import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Sphere;

/**
 * 
 */
public class PRSpriteBomb extends PRSprite {

	/** ̐F */
	private static final Color[]		COLORS			= new Color[]{
		Color.color(0.6, 0.6, 0.0, 0.2),
		Color.color(0.6, 0.6, 0.0, 0.4),
		Color.color(0.8, 0.8, 0.0, 0.6),
		Color.color(0.8, 0.8, 0.0, 0.8),
		Color.color(0.9, 0.9, 0.0, 1.0),
		Color.color(0.8, 0.8, 0.0, 0.8),
		Color.color(0.8, 0.8, 0.0, 0.6),
		Color.color(0.6, 0.6, 0.0, 0.4),
		Color.color(0.6, 0.6, 0.0, 0.2)
	};

	/** AvP[V */
	public		PRApplication			application		= null;

	/** XvCg */
	public		PRSprite				sprite			= null;

	/**  */
	private		Sphere					sphere			= null;

	/** }eA */
	private		PhongMaterial			material		= null;

	/** x */
	private		double					mx				= 0.0;
	private		double					my				= 0.0;
	private		double					mz				= 0.0;

	/**  */
	private		int						time			= 0;

	/** a */
	private		double					aRadius			= 0;

	/** Fʒu */
	private		int						posColors		= 0;

	/**
	 * RXgN^
	 * <pre>
	 * a0.02Őݒ肳܂B
	 * <pre>
	 * @param application PRApplication
	 * @param group Group XvCg
	 */
	public PRSpriteBomb(PRApplication application, PRSprite sprite) {

		this(application, sprite, 0.02);

	}

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param group Group XvCg
	 * @param aRadius a
	 */
	public PRSpriteBomb(PRApplication application, PRSprite sprite, double aRadius) {

		super(application);

		// AvP[Vێ
		this.application = application;

		// XvCgێ
		this.sprite = sprite;

		// ꏊݒ
		this.setTranslateX(sprite.getTranslateX());
		this.setTranslateY(sprite.getTranslateY());
		this.setTranslateZ(sprite.getTranslateZ() - 1);

		// avZ
		this.aRadius = aRadius;

		// 𐶐
		sphere = new Sphere(0.0, 16);

		// }eA𐶐
		material = new PhongMaterial(COLORS[0]);

		// }eAݒ
		sphere.setMaterial(material);

		// GXvCg̏ꍇA
		if(sprite instanceof PRSpriteT){

			// GXvCgɃLXg
			PRSpriteT spriteT = (PRSpriteT)sprite;

			// xݒ
			this.mx = spriteT.mx;
			this.my = spriteT.my;
			this.mz = spriteT.mz;

		} // end if GXvCg̏ꍇ

		// ǉ
		this.getChildren().add(sphere);

	} // end PRSpriteBomb

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		time++;

		// FʒuS̏ꍇA
		if(posColors < 4){

			// ʒuύX
			// XvCgɍ킹Ĕړ
			super.setTranslateX(sprite.getTranslateX());
			super.setTranslateY(sprite.getTranslateY());
			super.setTranslateZ(sprite.getTranslateZ());

		}else{

			// ʒuύX
			// XvCg폜Ă܂Ă̂ŁA擾xňړ
			super.setTranslateX(super.getTranslateX() + mx);
			super.setTranslateY(super.getTranslateY() + my);
			super.setTranslateZ(super.getTranslateZ() + mz);

		} // end if ʒuύX

		// 0.25b
		if(time < 15){

			// aݒ
			sphere.setRadius(sphere.getRadius() + aRadius);

		// 0.5b
		}else{

			// 0.05bPʂ̏ꍇA
			if(time % 3 == 0){

				// Fʒu{P
				posColors++;

				// FȂꍇA
				if(posColors >= COLORS.length){

					// AvP[Vm[h폜
					application.removeNode(this);

					// ^[
					return;

				}

				// FύX
				material.setDiffuseColor(COLORS[posColors]);

				// FʒuSɂȂꍇA
				if(posColors == 4){

					// XvCg폜
					application.removeNode(sprite);

				}

			} // end if // 0.2bPʂ̏ꍇ

		} // end if 0.5b

	} // end run

}
