import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Cylinder;
import javafx.scene.transform.Rotate;

/**
 * G̃[U[P
 */
public class PRSpriteLaserTeki1 extends PRSpriteT {

	/** [U[̐F */
	private static final Color[]	COLOR_LASER		= new Color[]{
		Color.color(1.0, 0.4, 0.1, 0.5),
		Color.color(1.0, 0.2, 0.1, 0.5),
		Color.color(1.0, 0.0, 0.1, 0.5)
	};

	/** GXvCg */
	private		PRSprite			sprite			= null;

	/** V_[ */
	private		Cylinder			cylinder		= null;

	/** }eA */
	private		PhongMaterial		materail		= null;

	/**  */
	private		int					time			= 0;

	/** x */
	private		double				mx				= 0;
	private		double				my				= 0;
	private		double				mz				= 0;

	/**
	 * 
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spritePrusher vC[
	 * @param speed G̒ẽXs[h
	 * @param flgBoss {XtO
	 */
	public PRSpriteLaserTeki1(PRApplication application, PRSprite sprite, boolean flgBoss) {

		super(application);

		// GXvCgێ
		this.sprite = sprite;

		// V_[𐶐
		cylinder = new Cylinder(0.25, 0.5, 12);

		// ]i90xXj
		cylinder.getTransforms().add(new Rotate(90, Rotate.X_AXIS));

		// V_[ǉ
		this.getChildren().add(cylinder);

		// W
		double x = sprite.getTranslateX();
		double y = sprite.getTranslateY();
		double z = sprite.getTranslateZ() - 0.25;

		// ʒuݒ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// }eA𐶐
		materail = new PhongMaterial();

		// }eAݒ
		cylinder.setMaterial(materail);

		// ʐFݒ
		materail.setSpecularPower(0.2);

		// {X̏ꍇA
		if(flgBoss){

			// 傫Q{ɂ
			super.setScaleX(2.0);
			super.setScaleY(2.0);

		}

		// eݒ
		application.addShadow(this);

		// xݒ
		mz = -0.05;

	} // end PRSpriteLaserTeki1

	/**
	 * s
	 */
	public void run(){

		// ʒu擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// ړ
		x = x + mx;
		y = y + my;
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < -10){

			// 폜
			application.removeNode(this);

		}

		// Pb܂
		if(time < 60){

			// GXvCgɈʒu킹
			x = sprite.getTranslateX();
			y = sprite.getTranslateY();

		// Pb
		}else if(time == 60){

			// GXvCg̕ێ폜
			this.sprite = null;

		}

		// ʒuݒ
		super.setTranslateX(x);
		super.setTranslateY(y);
		super.setTranslateZ(z);

		// Ԑݒ
		time++;

		// Pb܂
		if(time < 60){

			// L΂
			cylinder.setHeight(cylinder.getHeight() + 0.1);

		// Pb
		}else if(time == 60){

			// xݒ
			mz = -1.0;

		} // end if 

		// e̐F̐ݒ
		materail.setDiffuseColor(COLOR_LASER[time % 3]);
		materail.setSpecularColor(COLOR_LASER[time % 3]);

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 蔻͈Z
	 */
//	@Override
//	public double getHaniZ() {
//		return 2.0;
//	}

}
