/**
 * 石
 */
public class PRSpriteGroupStone extends PRSpriteGroup implements PRConstant {

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 */
	public PRSpriteGroupStone(PRApplication application){
		super(application);
	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 一定時間経過の場合、
		if((time % 30) == 0){

			// スプライトを生成
			PRSpriteStone spriteStone = new PRSpriteStone(super.getPRApplication());

			// スプライトを追加
			super.getPRApplication().addNode(spriteStone);

		} // end if 一定時間経過の場合

		// ５秒経ったら、
		if(time > 300){
			// スプライトグループを消す
			super.getPRApplication().removeSpriteGroup(this);
		}

	} // end run

}
